//---------------------------------------------------------------------------
// ReEntry Problem by dllee<dllee@edirect168.com>  <2004-05-04>
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "ReEntryUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
  Timer1->Enabled=false;
  Timer1->Interval=1000;
  Timer2->Enabled=false;
  Timer2->Interval=3000;
  Timer3->Enabled=true;   // Timer3 OΨӧP_ GUI O_w
  Timer3->Interval=100;

  Function1Running=false;
  Function2Running=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::TestFunction1(TObject *Sender)
{
  TTimer *timer=dynamic_cast<TTimer*>(Sender);
  if(timer!=NULL)
    ListBox1->Items->Add(Now().FormatString("HH:NN:SS ")+timer->Name+" try to use Function1...");

  while(Function1Running==true) // pGe٨S槹NA@U
  {
    Application->ProcessMessages();
    if(CheckBox2->Checked)  Sleep(10);  // pGݭn Sleep()
  }
  Function1Running=true;        // }l]wX
  if(timer!=NULL)
    ListBox1->Items->Add(Now().FormatString("HH:NN:SS ")+timer->Name+" start using Function1...");

  int *testMemory=new int[64*1024*1024];  // o 64 MB O
  for(int i=0;i<64*1024*1024;i++)
  {
    if( CheckBox1->Checked  // pGݭn Application->ProcessMessages()
    && i%(1024*1024)==0 )   // hb for loop |Ĳo 64 
      Application->ProcessMessages();

    testMemory[i]=i*i/123;  // @NBӮOɶAHu{UعB
  }
  delete [] testMemory;

  if(timer!=NULL)
    ListBox1->Items->Add(Now().FormatString("HH:NN:SS ")+timer->Name+" finished Function1...");

  Function1Running=false;        // 槹MX
}
//---------------------------------------------------------------------------
void __fastcall TForm1::TestFunction2(TObject *Sender)
{
  TTimer *timer=dynamic_cast<TTimer*>(Sender);
  if(timer!=NULL)
    ListBox1->Items->Add(Now().FormatString("HH:NN:SS ")+timer->Name+" try to use Function2...");

  while(Function2Running==true) // pGe٨S槹NA@U
  {
    Application->ProcessMessages();
    if(CheckBox2->Checked)  Sleep(10);  // pGݭn Sleep()
  }
  Function2Running=true;        // }l]wX
  if(timer!=NULL)
    ListBox1->Items->Add(Now().FormatString("HH:NN:SS ")+timer->Name+" start using Function2...");

  // sΤT TestFunction1
  for(int i=0;i<3;i++)
    TestFunction1(Sender);

  if(timer!=NULL)
    ListBox1->Items->Add(Now().FormatString("HH:NN:SS ")+timer->Name+" finished Function2...");

  Function2Running=false;        // 槹MX
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
  ListBox1->Items->Add(Now().FormatString("HH:NN:SS ")+"Timer1 Entered");
  TestFunction1(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer2Timer(TObject *Sender)
{
  ListBox1->Items->Add(Now().FormatString("HH:NN:SS ")+"Timer2 Entered");
  TestFunction2(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  ListBox1->Items->Add(Now().FormatString("HH:NN:SS ")
    +"Test Started ------------ Timer ON");
  Timer1->Enabled=true;
  Timer2->Enabled=true;

  Function1Running=false;
  Function2Running=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
  Timer1->Enabled=false;
  Timer2->Enabled=false;
  ListBox1->Items->Add(Now().FormatString("HH:NN:SS ")
    +"Test Finished ----------- Timer OFF");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer3Timer(TObject *Sender)
{ //  Timer ΨӬd GUI O_٥iާ@
  Label1->Caption=String(Label1->Caption.ToIntDef(0)+1);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
  ListBox1->Items->Add(Now().FormatString("HH:NN:SS ")+"Close()");
  Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
  ListBox1->Items->Add(Now().FormatString("HH:NN:SS ")+"Application->Terminate()");
  Application->Terminate();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button5Click(TObject *Sender)
{
  ListBox1->Items->SaveToFile(Now().FormatString("YYYYMMDD_HHNNSS")+".log");  
}
//---------------------------------------------------------------------------

